#include "EsoAcsammm_Header.hpp"
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */
/* We do not support C11 <threads.h>.  */
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double var_x=0;
   double a1_var_x=0;
   double der_var_x=0;
   double a1_der_var_x=0;
   double var_y=0;
   double a1_var_y=0;
   double der_var_y=0;
   double a1_der_var_y=0;
   double var_z=0;
   double a1_var_z=0;
   double der_var_z=0;
   double a1_der_var_z=0;
   double par_Para=0;
   double a1_par_Para=0;
   double par_Cont=0;
   double a1_par_Cont=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=var_x; acs_fds_c=acs_fds_c+1; var_x=x[0];
      acs_fds[acs_fds_c]=der_var_x; acs_fds_c=acs_fds_c+1; der_var_x=der_x[0];
      acs_fds[acs_fds_c]=var_y; acs_fds_c=acs_fds_c+1; var_y=x[1];
      acs_fds[acs_fds_c]=der_var_y; acs_fds_c=acs_fds_c+1; der_var_y=der_x[1];
      acs_fds[acs_fds_c]=var_z; acs_fds_c=acs_fds_c+1; var_z=x[2];
      acs_fds[acs_fds_c]=der_var_z; acs_fds_c=acs_fds_c+1; der_var_z=der_x[2];
      acs_fds[acs_fds_c]=par_Para; acs_fds_c=acs_fds_c+1; par_Para=p[0];
      acs_fds[acs_fds_c]=par_Cont; acs_fds_c=acs_fds_c+1; par_Cont=p[1];
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_x-(par_Para*par_Cont);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_y-(5*par_Para);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_z-(0.37256);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // For the case you need the actual function value at the end of the forward section, use this mode for storing it.
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
            acs_cs_c=acs_cs_c-1;
            if (acs_cs[acs_cs_c]==0) {
              acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_z;
              v1_1=0.37256;
              v1_2=v1_1;
              v1_3=v1_0-v1_2;
              a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_v1_1=a1_v1_2;
              a1_var_z=a1_var_z+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_y;
              v1_1=5;
              v1_2=par_Para;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_par_Para=a1_par_Para+a1_v1_2;
              a1_var_y=a1_var_y+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_x;
              v1_1=par_Para;
              v1_2=par_Cont;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_par_Cont=a1_par_Cont+a1_v1_2;
              a1_par_Para=a1_par_Para+a1_v1_1;
              a1_var_x=a1_var_x+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_Cont=acs_fds[acs_fds_c];
              v1_0=p[1];
              a1_v1_0=a1_par_Cont; a1_par_Cont=0;
              a1_p[1]=a1_p[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_Para=acs_fds[acs_fds_c];
              v1_0=p[0];
              a1_v1_0=a1_par_Para; a1_par_Para=0;
              a1_p[0]=a1_p[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z=acs_fds[acs_fds_c];
              v1_0=der_x[2];
              a1_v1_0=a1_der_var_z; a1_der_var_z=0;
              a1_der_x[2]=a1_der_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z=acs_fds[acs_fds_c];
              v1_0=x[2];
              a1_v1_0=a1_var_z; a1_var_z=0;
              a1_x[2]=a1_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_y=acs_fds[acs_fds_c];
              v1_0=der_x[1];
              a1_v1_0=a1_der_var_y; a1_der_var_y=0;
              a1_der_x[1]=a1_der_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_y=acs_fds[acs_fds_c];
              v1_0=x[1];
              a1_v1_0=a1_var_y; a1_var_y=0;
              a1_x[1]=a1_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_x=acs_fds[acs_fds_c];
              v1_0=der_x[0];
              a1_v1_0=a1_der_var_x; a1_der_var_x=0;
              a1_der_x[0]=a1_der_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_x=acs_fds[acs_fds_c];
              v1_0=x[0];
              a1_v1_0=a1_var_x; a1_var_x=0;
              a1_x[0]=a1_x[0]+a1_v1_0;
            }
          }
       }
       if (bmode_1==2) {
          res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
       }
}
